/***************************************************************************
 *  Copyright  2008  Marcus Bauer
 *  License    GPLv2
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "globals.h"
#include "map_management.h"
#include "converter.h"
#include "gps_functions.h"
#include "friends.h"
#include "init.h"

static int mouse_x = 0;
static int mouse_y = 0;
	static int wtfcounter=0; //workaround: motion notify event comes BEFORE press!

//FIXME - this is brain fuck hack
static int local_x = 0;
static int local_y = 0;

//TODO move this func to right filegtk_toggle_button_get_active
void
print_track()
{	
	GSList *list;
	int pixel_x, pixel_y, x,y;
	float lat, lon;
	GdkColor color;
	GdkGC *gc;
	
	gc = gdk_gc_new(pixmap);
	color.green = 0;
	color.blue = 0;
	color.red = 60000;
	gdk_gc_set_rgb_fg_color(gc, &color);
	

	
			
		
		
		
	

	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	for(list = trackpoint_list; list != NULL; list = list->next)
	{
		trackpoint_t *tp = list->data;
	
		lat = tp->lat;
		lon = tp->lon;
		
		
		
		// pixel_x,y, offsets
		pixel_x = lon2pixel(global_zoom, lon);
		pixel_y = lat2pixel(global_zoom, lat);
		
		x = pixel_x - global_x;
		y = pixel_y - global_y;
		
		gdk_draw_arc (
			pixmap,
			//map_drawable->style->black_gc,
			gc,
			TRUE,			//filled
			x-4, y-4,		// x,y
			8,8,			// width, height
			0,23040);		// start-end angle 64th, from 3h, anti clockwise
		
		gtk_widget_queue_draw_area (
			map_drawable, 
			x-4, y-4,
			8,8);

		printf("Trackpoint: lat %f - lon %f\n",tp->lat, tp->lon);
	}
}

gboolean
on_drawingarea1_button_press_event     (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	printf("** button press event %d %d\n", (int)event->x, (int)event->y);
	wtfcounter = 0;
	if (
		(event->type==GDK_BUTTON_PRESS ||
		 event->type==GDK_2BUTTON_PRESS) )
	{
		printf("#### I feel %s clicked with button %d\n",
			event->type==GDK_BUTTON_PRESS ? "single" : "double",
			event->button);
		if(event->type==GDK_2BUTTON_PRESS) on_button4_clicked(NULL,NULL);
			//TODO:needs timer or kill popup
	}
	
	mouse_x = (int) event->x;
	mouse_y = (int) event->y;
	local_x = global_x;
	local_y = global_y;
	/*
	global_x += (int)event->x;
	global_y += (int)event->y;
	
	fill_tiles_pixel(global_x, global_y, global_zoom);
	*/
	//if (event->button == 1 && pixmap != NULL)
		//draw_circle (widget, event->x, event->y);
		
  return FALSE;
}

gboolean
on_drawingarea1_button_release_event   (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	GtkMenu *menu;
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
	
	//if(global_mapmode)
	if(wtfcounter >= 6)
	{
		printf("* mouse drag +8events\n");
		int mouse_dx, mouse_dy;
		
		global_x = local_x;//FIXME unnecessary oder auch nicht: kein redraw, wenn nicht bewegt
		global_y = local_y;
		
		mouse_dx = mouse_x - (int) event->x;//FIXME entweder dx oder mouse_dx
		mouse_dy = mouse_y - (int) event->y;
		
		global_x += mouse_dx;//TODO hier gibt es einige pixel offset.
		global_y += mouse_dy;
	
		gdk_draw_rectangle (
			pixmap,
			widget->style->white_gc,
			TRUE,
			0, 0,
			widget->allocation.width+260,
			widget->allocation.height+260);
					
		gtk_widget_queue_draw_area (
			widget, 
			0,0,widget->allocation.width+260,widget->allocation.height+260);
		
		fill_tiles_pixel(global_x, global_y, global_zoom);	//FIXME zoom
		wtfcounter = 0;
	
		print_track();
		paint_friends();
		//printf("mouse delta: %d %d\n", mouse_dx, mouse_dy);
	}
	else
	{
		menu = create_menu1(); //GTK_MENU(lookup_widget(window1,"menu1"));

		gtk_menu_popup (menu, NULL, NULL, NULL, NULL, 
			  event->button, event->time);
		wtfcounter = 0;
	}
  return FALSE;
}

gboolean
on_drawingarea1_motion_notify_event    (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
	if(global_mapmode)
	{
		//printf("motion event\n");
		static int dx = 0; // for mouse move pixmap FIXME
		static int dy = 0;
		int x, y, width, height;
		GdkModifierType state;
		
		width  = map_drawable->allocation.width;//only to repaint the whole thing
		height = map_drawable->allocation.height;//FIXME: better dont do this?
		
		if (event->is_hint)
			gdk_window_get_pointer (event->window, &x, &y, &state);
		else
		{
			x = event->x;
			y = event->y;
			state = event->state;
		}
	 
		//if (state & GDK_BUTTON1_MASK && pixmap != NULL)
		//	draw_brush (widget, x, y);
		if (state & GDK_BUTTON1_MASK  && wtfcounter>=6) {
		
		global_autocenter = FALSE;
			
		dx = x - mouse_x;	
		dy = y - mouse_y;
			
		gdk_draw_drawable (
			widget->window,
			widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
			pixmap,
			0,0,
			dx,dy,
			-1,-1);
			//width+50,height+50);//FIXME test offset 20; better:-1;
	//dx++;dy++; if(dx>width) dx=0; if(dy>height) dy=0;
	/*		
			mouse_dx = mouse_x - (int) event->x;
			mouse_dy = mouse_y - (int) event->y;
			
			global_x = local_x;
			global_y = local_y;
			
			global_x += mouse_dx;
			global_y += mouse_dy;
	*/		
			printf("motion: %i %i - start: %i %i - dx: %i %i --wtf %i\n", x,y, mouse_x, mouse_y, dx, dy,wtfcounter);
			//fill_tiles_pixel(global_x, global_y, global_zoom);	
		}	
		else
			wtfcounter++;
	}
	
  return FALSE;
}

/* -------------- map initialisation ----------------- */
gboolean
on_drawingarea1_configure_event        (GtkWidget         *widget,
                                        GdkEventConfigure *event,
                                        gpointer           user_data)
{
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
	
	map_drawable = widget;
	
	global_drawingarea_width  = widget->allocation.width;
	global_drawingarea_height = widget->allocation.height;
	/* create pixmap */
	if (pixmap)
		g_object_unref (pixmap);

	pixmap = gdk_pixmap_new (
			widget->window,
			widget->allocation.width+260, //TODO: this could be cleverer
			widget->allocation.height+260,
			-1);
//TODOremove or not...
//#if 0
if(pixmap) printf("pixmap NOT NULL");
else printf("aieee: pixmap NULL\n");

	/* draw white background to initialise pixmap */
	gdk_draw_rectangle (
		pixmap,
		widget->style->white_gc,
		TRUE,
		0, 0,
		widget->allocation.width+260,
		widget->allocation.height+260);
				
	gtk_widget_queue_draw_area (
		widget, 
		0,0,widget->allocation.width+260,widget->allocation.height+260);
//#endif

	//todo: is this double call on init()?
	//needed for resize event
	fill_tiles_pixel(global_x, global_y, global_zoom);//TODO is x,y always set?
	
return FALSE;
}


gboolean
on_drawingarea1_expose_event           (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
	/* debug */
	printf("** expose event\n");
	
	gdk_draw_drawable (
		widget->window,
		widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		pixmap,
		event->area.x, event->area.y,
		event->area.x, event->area.y,
		event->area.width, event->area.height);
	
	
	return FALSE;
}

void
on_button1_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *notebook;
	static int maximized = FALSE;
	
	printf("button1 clicked\n");
	notebook = lookup_widget(GTK_WIDGET(button), "notebook1");
	
	if(!maximized)
	{
		
		gtk_notebook_set_show_tabs(notebook,FALSE);
		gtk_window_fullscreen(window1);
		fill_tiles_pixel(global_x, global_y, global_zoom);

		maximized = TRUE;
	}
	else
	{
		gtk_window_unfullscreen(window1);
		gtk_notebook_set_show_tabs(notebook,TRUE);
		//fill_tiles_pixel(global_x, global_y, global_zoom);
		//printf("fill: x %i y %i zoom %i\n", global_x, global_y, global_zoom);

		maximized = FALSE;
	}
	//load_tiles();
}

void
on_button2_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	float lat, lon;
	printf("button2 clicked\n");
	
	lat = deg2rad(51.52468);
	lon = deg2rad(-0.13762);
	fill_tiles_latlon(lat, lon, 15);
}



void
on_vscale1_value_changed               (GtkRange        *range,
                                        gpointer         user_data)
{
#if 0
	int zoom_old;
	float factor;
	int width_center, height_center;
	
	width_center  = map_drawable->allocation.width 	/ 2;
	height_center = map_drawable->allocation.height / 2;
	
	printf("x vorher: %d",global_x);
	
	zoom_old = global_zoom;

	global_zoom = gtk_range_get_value(range);
	factor = exp2(global_zoom)/exp2(zoom_old);

	// hier
	//global_x *= factor;
	//global_y *= factor;
	
	global_x = ((global_x + width_center) * factor) - width_center;
	global_y = ((global_y + height_center) * factor) - height_center;
	
	
	fill_tiles_pixel(global_x, global_y, global_zoom);

	//FIXME TODO: wenn zoom ändert, müssen sich auch globalx y ändern
	printf("zoom changed from %d to %d factor: %f x: %d\n",
	zoom_old,global_zoom, factor, global_x);
#endif
}
void
on_button4_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *range;
	
	
	int zoom_old;
	float factor;
	int width_center, height_center;

	if(global_zoom<17)
	{	
		range = lookup_widget(window1, "vscale1");
		
		width_center  = map_drawable->allocation.width 	/ 2;
		height_center = map_drawable->allocation.height / 2;
		
		printf("x vorher: %d",global_x);
		
		zoom_old = global_zoom;
	
		global_zoom++;
		gtk_range_set_value(range, (double) global_zoom);
		factor = exp2(global_zoom)/exp2(zoom_old);
	
		// hier
		//global_x *= factor;
		//global_y *= factor;
		
		global_x = ((global_x + width_center) * factor) - width_center;
		global_y = ((global_y + height_center) * factor) - height_center;
		
		
		fill_tiles_pixel(global_x, global_y, global_zoom);
	
		//FIXME TODO: wenn zoom ändert, müssen sich auch globalx y ändern
		printf("zoom changed from %d to %d factor: %f x: %d\n",
		zoom_old,global_zoom, factor, global_x);
	
		print_track();
		paint_friends();
	}
}


void
on_button3_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	global_autocenter = TRUE;
	
	if(gpsdata)
	{
		//printf("lat %f lon %f zoom %i",deg2rad(gpsdata->fix.latitude), deg2rad(gpsdata->fix.longitude), global_zoom);
		if(isnan(gpsdata->fix.latitude)==0 && isnan(gpsdata->fix.longitude)==0)
			set_mapcenter(gpsdata->fix.latitude, gpsdata->fix.longitude, global_zoom);
	}
	else
		printf("***************************\n");
	printf("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
}

gboolean
on_window1_delete_event                (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	printf("%s()\n",__PRETTY_FUNCTION__);
	gtk_main_quit();
	
	return FALSE; //-> FALSE=destroy event follows
}


gboolean
on_window1_destroy_event               (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
	printf("%s()\n",__PRETTY_FUNCTION__);
	gtk_main_quit();
	return FALSE;
}


void
on_button5_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	int zoom_old;
	float factor;
	int width_center, height_center;
		GtkWidget *range;
	if(global_zoom>2)
	{
		range = lookup_widget(window1, "vscale1");
	
		width_center  = map_drawable->allocation.width 	/ 2;
		height_center = map_drawable->allocation.height / 2;
		
		printf("x vorher: %d",global_x);
		
		zoom_old = global_zoom;
	
		global_zoom--;
		gtk_range_set_value(range, (double) global_zoom);
	
		factor = exp2(global_zoom)/exp2(zoom_old);
	
		// hier
		//global_x *= factor;
		//global_y *= factor;
		
		global_x = ((global_x + width_center) * factor) - width_center;
		global_y = ((global_y + height_center) * factor) - height_center;
		
		
		fill_tiles_pixel(global_x, global_y, global_zoom);
	
		//FIXME TODO: wenn zoom ändert, müssen sich auch globalx y ändern
		printf("zoom changed from %d to %d factor: %f x: %d\n",
		zoom_old,global_zoom, factor, global_x);
		print_track();
		paint_friends();
	}
}

void
on_item1_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_item2_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}

gboolean
on_vscale1_change_value                (GtkRange        *range,
                                        GtkScrollType    scroll,
                                        gdouble          value,
                                        gpointer         user_data)
{

  return FALSE;
}

gboolean
on_vscale1_button_press_event          (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{

  return FALSE;
}


gboolean
on_vscale1_button_release_event        (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
	printf("%s(): \n", __PRETTY_FUNCTION__);
	
		int zoom_old;
	float factor;
	int width_center, height_center;
	
	width_center  = map_drawable->allocation.width 	/ 2;
	height_center = map_drawable->allocation.height / 2;
	
	printf("x vorher: %d",global_x);
	
	zoom_old = global_zoom;

	global_zoom = gtk_range_get_value(widget);
	factor = exp2(global_zoom)/exp2(zoom_old);

	// hier
	//global_x *= factor;
	//global_y *= factor;
	
	global_x = ((global_x + width_center) * factor) - width_center;
	global_y = ((global_y + height_center) * factor) - height_center;
	
	
	fill_tiles_pixel(global_x, global_y, global_zoom);

	//FIXME TODO: wenn zoom ändert, müssen sich auch globalx y ändern
	printf("zoom changed from %d to %d factor: %f x: %d\n",
	zoom_old,global_zoom, factor, global_x);
	
	
  return FALSE;
}


void
on_combobox1_changed                   (GtkComboBox     *combobox,
                                        gpointer         user_data)
{
	GSList	*list;
	gchar *reponame_combo;
	GError **error = NULL;
	gboolean success = FALSE;

	printf("%s():\n",__PRETTY_FUNCTION__);
	
	reponame_combo = gtk_combo_box_get_active_text(combobox);
	// global repo name setzen aus combobox value
	global_repo_curr_name = g_strdup(reponame_combo);
	// populate values
	///// global repo curr SETZEN
	for(list = global_repo_list; list != NULL; list = list->next)
	{
		repo_t	*repo;
		gchar	*reponame;

		repo = list->data;
		reponame = g_strdup(repo->name);
		printf("*** %s(): reponame: %s %s\n",__PRETTY_FUNCTION__,reponame,repo->uri);
		
		if(	g_strrstr(reponame,global_repo_curr_name) != NULL &&
			strlen(reponame) == strlen(global_repo_curr_name)	
		) 
		{
			//j = i;
			global_repo_curr = list;
		}
		//i++;
	}
	
	
	success = gconf_client_set_string(
					global_gconfclient, 
					GCONF"/repo_name",
					global_repo_curr_name,
					error);
	
	
	repo_config_populate_dialog();
}

void
on_checkbutton1_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gboolean	toggled;
	repo_t *repo;
	
	repo = global_repo_curr->data;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
	toggled = gtk_toggle_button_get_active(togglebutton);
	repo->inverted_zoom = toggled;

}


void
on_dialog1_close                       (GtkDialog       *dialog,
                                        gpointer         user_data)
{
	printf("*** %s(): \n",__PRETTY_FUNCTION__);

}


void
on_dialog1_response                    (GtkDialog       *dialog,
                                        gint             response_id,
                                        gpointer         user_data)
{
	printf("*** %s(): \n",__PRETTY_FUNCTION__);

}


void
on_cancelbutton1_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*entry;

	entry = lookup_widget(dialog1, "entry5");
	
	gtk_entry_set_text(entry,"");
	gtk_widget_hide(dialog1);

	printf("*** %s(): \n",__PRETTY_FUNCTION__);
}


void
on_okbutton1_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*entry;
	GtkWidget	*combobox;
	GtkWidget	*entry_uri;
	GtkWidget	*entry_dir;
	GtkWidget	*togglebutton;
	const gchar	*reponame;
	repo_t *repo = g_new0(repo_t, 1);
	
	gtk_widget_hide(dialog1);
	
	entry = lookup_widget(dialog1, "entry5");
	entry_uri = lookup_widget(window1, "entry1");
	entry_dir = lookup_widget(window1, "entry2");
	togglebutton = lookup_widget(window1, "checkbutton1");
	combobox = lookup_widget(window1, "combobox1");

	reponame = gtk_entry_get_text(entry);
	gtk_combo_box_append_text (combobox, g_strdup(reponame));
	gtk_combo_box_set_active(GTK_COMBO_BOX(combobox), global_repo_cnt);
	global_repo_cnt++;
	


	repo->name = g_strdup(reponame);
	//repo->dir = g_strdup("dir");
	//repo->uri = g_strdup("uri");
	repo->inverted_zoom = FALSE;
	
	global_repo_list = g_slist_prepend(global_repo_list, repo);
	global_repo_curr = global_repo_list;
	
	gtk_entry_set_text(entry_uri, "");
	gtk_entry_set_text(entry_dir, "");
	gtk_toggle_button_set_active(togglebutton, FALSE);

	// get text, set clear
	// append an dd, alle felder clear
	printf("*** %s(): new repo: %s\n",__PRETTY_FUNCTION__, reponame);
	gtk_entry_set_text(entry,"");

// new repo_t
// an global liste appenden
// on change text repo_t updaten
//// on save: serialize und in gconf
}


void
on_button7_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	
	gtk_widget_show(dialog1);
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
}

void
on_entry1_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	GtkWidget	*entry_uri;
	const gchar	*uri;
	repo_t *repo;
	
	entry_uri = lookup_widget(window1, "entry1");
	uri = gtk_entry_get_text(entry_uri);

	repo = global_repo_curr->data;
	repo->uri = g_strdup(uri);
	global_repo_curr->data = repo;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);

}


void
on_entry2_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	GtkWidget	*entry_dir;
	const gchar	*dir;
	repo_t *repo;
	
	entry_dir = lookup_widget(window1, "entry2");
	dir = gtk_entry_get_text(entry_dir);

	repo = global_repo_curr->data;
	repo->dir = g_strdup(dir);
	global_repo_curr->data = repo;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
}

void
on_button6_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
	repo_config_to_gconf();
}

void
on_button8_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
	trackpoint_list = NULL;
	trip_distance = 0;
	trip_starttime = 0;
	trip_time =0;
	trip_maxspeed = 0;
}

void
on_checkbutton2_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	gboolean	toggled;
		
	toggled = gtk_toggle_button_get_active(togglebutton);
	global_auto_download = toggled;

}


void
on_button9_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*entry_server, *entry_port;
	const gchar	*server, *port;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	entry_server	= lookup_widget(window1, "entry3");
	entry_port	= lookup_widget(window1, "entry4");
	server	= gtk_entry_get_text(entry_server);
	port	= gtk_entry_get_text(entry_port);
	global_server	= g_strdup(server);
	global_port	= g_strdup(port);
	gpsdata = NULL;
}

void
on_button10_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*entry_command;
	const gchar	*command;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	entry_command = lookup_widget(window1, "entry6");
	command = gtk_entry_get_text(entry_command);
	printf("cmd: %s\n",command);
	system(command);
	
}

void
on_button11_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	// mini-php
	// thread
	// libcurl: f.c,f.h,prj,inc, simple get-string, ret val,
	// lat,lon...
	// set label w/ reply
	update_position();
}


void
on_button12_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	// thread
	// libcurl - in2mem,stringsplit
	// lat,lon
	// set label or kick to tab1
	// make list
	// draw points
	// tap - mode, pop-up
	
}

void
on_togglebutton1_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	global_mapmode = (gtk_toggle_button_get_active(togglebutton)) ? FALSE : TRUE;
	if(!global_mapmode)
		gtk_button_set_label(togglebutton, "tap");
	else
		gtk_button_set_label(togglebutton, "map");
}

void
on_item3_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{	
	GSList *list;
	GtkWidget *label;
	gchar buffer[1024];//FIXME potential crasher
	gboolean friend_found = FALSE;

	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	g_sprintf(buffer, "Friends");//"<b><u>Friends</u></b>"); //markup use?
	
	for(list = friends_list; list != NULL; list = list->next)
	{
		friend_t *f = list->data;
		printf("\n\nPIXEL FRENDS: %d %d   \n\n",f->screen_x,f->screen_y);
		if( 	abs(f->screen_x - mouse_x) < 9 &&
			abs(f->screen_y - mouse_y) < 9)
		{
			printf("FOUND FRIEND X: %d %d %s\n",f->screen_x, mouse_x,f->nick);
	
			//TODO handle multiple finds
			g_sprintf(buffer, 
				"%s \n"
				"Nickname: %s \n"
				"Last seen: %s",
				buffer,
				f->nick,
				f->lastseen);
			friend_found = TRUE;
		}
	
	}
	
	if (!friend_found)
		g_sprintf(buffer,"No friends at or near this position");

	
	label = lookup_widget(window2,"label64");
	gtk_label_set_text(label,buffer);
	
	gtk_widget_show (window2);
}

void
on_item4_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	GtkWidget *label;
	gchar buffer[512];
	float lat, lon,lat_deg,lon_deg;
	float distance=0;
	
	
	printf("screen x,y: %d %d \n",mouse_x, mouse_y);
	lat = pixel2lat(global_zoom, global_y+mouse_y);
	lon = pixel2lon(global_zoom, global_x+mouse_x);
	
	lat_deg = rad2deg(lat);
	lon_deg = rad2deg(lon);
	printf ("##### Lonitude: %f %f - %f %f \n", lat, lon, lat_deg, lon_deg);
	
	if(gpsdata !=NULL)
	{
		distance = 	6731.0 *  
				acos(sin(deg2rad(gpsdata->fix.latitude)) * 
				sin(lat) +
		
				cos(deg2rad(gpsdata->fix.latitude)) * 
				cos(lat) * 
				cos(lon - deg2rad(gpsdata->fix.longitude)) );
	}
	else if(global_myposition.lat && global_myposition.lon)
	{
		distance = 	6731.0 *  
				acos(sin(deg2rad(global_myposition.lat)) * 
				sin(lat) +
		
				cos(deg2rad(global_myposition.lat)) * 
				cos(lat) * 
				cos(lon - deg2rad(global_myposition.lon)) );
				
	}
	
	label = lookup_widget(window2,"label64");
	
	g_sprintf(buffer,"This point: \n"
			"%f %f \n\n"
			"Distance from your location: %.2fkm",lat_deg,lon_deg,distance);
	gtk_label_set_text(label,buffer);
	gtk_widget_show (window2);

}



void
on_button14_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget *window;
	window = lookup_widget(button, "window2");
	gtk_widget_hide(window);
}

void
on_item5_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	//TODO this is mostly duplicate code w/position
	GtkWidget *label;
	gchar buffer[512];
	float lat, lon,lat_deg,lon_deg;
	
	
	printf("screen x,y: %d %d \n",mouse_x, mouse_y);
	lat = pixel2lat(global_zoom, global_y+mouse_y);
	lon = pixel2lon(global_zoom, global_x+mouse_x);
	
	lat_deg = rad2deg(lat);
	lon_deg = rad2deg(lon);
	printf ("##### Lonitude: %f %f - %f %f \n", lat, lon, lat_deg, lon_deg);
	
	global_myposition.lat = lat_deg;
	global_myposition.lon = lon_deg;

	label = lookup_widget(window2,"label64");
	
	g_sprintf(buffer,"This point: \n"
			"%f %f \n\n"
			"is now set as your location",
			global_myposition.lat,
			global_myposition.lon);
			
	gtk_label_set_text(label,buffer);
	gtk_widget_show (window2);
}

gboolean
on_drawinarea1_scroll_event            (GtkWidget       *widget,
                                        GdkEventScroll  *event,
                                        gpointer         user_data)
{
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);
	if ((event->state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
		if (event->direction == GDK_SCROLL_UP) {
			printf("SCROLL UP+Ctrl\n");
		} else {
			printf("SCROLL DOWN+Ctrl\n");
		}
		return TRUE;
	}
	else
	{
		if (event->direction == GDK_SCROLL_UP)
		{
			printf("SCROLL UP\n");
			on_button4_clicked(NULL,NULL);
		}
		else
		{
			printf("SCROLL DOWN\n");
			on_button5_clicked(NULL,NULL);

		}
		return TRUE;
	}

//	  return FALSE;
}

void
on_button15_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	trip_counter_on = (trip_counter_on) ? FALSE : TRUE;
	
	if(trip_counter_on)
		gtk_button_set_label(button, "      Stop      ");
	else
		gtk_button_set_label(button, "      Start      ");
}

void
on_entry7_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	GtkWidget *nick;
	const gchar *n;
	GError **error = NULL;
	gboolean success = FALSE;
	
	nick  = lookup_widget(window1, "entry7");
	
	n = gtk_entry_get_text(nick);
		
	success = gconf_client_set_string(
					global_gconfclient, 
					GCONF"/nick",
					n,
					error);
}


void
on_entry8_changed                      (GtkEditable     *editable,
                                        gpointer         user_data)
{
	GtkWidget *pass;
	const gchar *p;
	GError **error = NULL;
	gboolean success = FALSE;
	
	pass  = lookup_widget(window1, "entry8");
	
	p = gtk_entry_get_text(pass);
	
	
	success = gconf_client_set_string(
					global_gconfclient, 
					GCONF"/pass",
					p,
					error);

}

void
on_button13_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	register_nick();
}

void
on_button16_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*entry_command;
	const gchar	*command;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	entry_command = lookup_widget(window1, "entry10");
	command = gtk_entry_get_text(entry_command);
	printf("cmd: %s\n",command);
	system(command);
}

void
on_button17_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
	GtkWidget	*entry_command;
	const gchar	*command;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	entry_command = lookup_widget(window1, "entry11");
	command = gtk_entry_get_text(entry_command);
	printf("cmd: %s\n",command);
	system(command);
}
