/***************************************************************************
 *            friends.c
 *
 *  Tue Feb 12 16:57:40 2008
 *  Copyright  2008  Marcus Bauer
 *  Email
 *  License    GPLv2
 ****************************************************************************/

#include "friends.h"
#include "globals.h"
#include "converter.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <gps.h>

#include <curl/curl.h>
#include <curl/types.h>
#include <curl/easy.h>


struct mem_struct {
	char *memory;
	size_t size;
};


static size_t
cb_write_to_mem(void *ptr, size_t size, size_t nmemb, void *data)
{
	size_t realsize = size * nmemb;
	struct mem_struct *mem = (struct mem_struct *)data;
	
	mem->memory = (char *)g_realloc(mem->memory, mem->size + realsize + 1);
	
	if (mem->memory)
	{
		memcpy(&(mem->memory[mem->size]), ptr, realsize);
		mem->size += realsize;
		mem->memory[mem->size] = 0;
	}
	return realsize;
}

// g_thread_create drumherum
// daten zusammensuchen: 
// - nick entry7,pw 8 email 9
// - lat,lon,speed,heading
// - v_public=y c3,v_member=y c4,v_friend=y c5
// - g_public=y 6,g_member=y 7,g_friend=y 8
//

// check if fix da.
// label setzen
// getinfo
// timer+active-vis-feedback,one-button,signup?,messages
// replymsg|type#nick#lat#lon#head#time#msg|[..]
// okay|3#JohnDoe#3.8738993#47.9384673#321#12:23:55#howdy?|
// 
// MESSAGES. 
// wenn indep: zusammenbringen -> das bedeuted db.
// delete?
// get messages, send messages
// what: who, content
// display: on map + as list

/*
	GtkWidget	*entry_uri;
	const gchar	*uri;
	
	entry_uri = lookup_widget(window1, "entry1");
	uri = gtk_entry_get_text(entry_uri);

	
	gboolean	toggled;
	toggled = gtk_toggle_button_get_active(togglebutton);
	w
	gpsdata->fix.latitude, gpsdata->fix.longitude
*/

int
update_position()
{		
	GtkWidget *label_msg;
	label_msg = lookup_widget(window1, "label51");
	gtk_label_set_text(label_msg, "Connecting...");

	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	if (!g_thread_create(&update_position_thread, NULL, FALSE, NULL) != 0)
		g_warning("### can't create friend thread\n");
}
	
int
update_position_thread(void *ptr)
{
	int i=1;
	
	GtkWidget *v_public, *v_member, *v_friend;
	GtkWidget *g_public, *g_member, *g_friend;
	GtkWidget *nick, *pass, *email;
	GtkWidget *label_msg;
	const gchar *n, *p, *e;	
	gchar *vp, *vm, *vf, *gp, *gm, *gf;
	gchar lat[64], lon[64];
	
	gchar **server_message, **user_data_sets, **user_data;
	long int response_code;
	
	CURL *curl_handle;
	
	struct curl_httppost *formdata=NULL;
	struct curl_httppost *lastptr=NULL;
		
	struct mem_struct chunk;
	
	chunk.memory=NULL;
	chunk.size = 0;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);


	label_msg = lookup_widget(window1, "label51");

	/* get the info from the widgets */
	v_public = lookup_widget(window1, "checkbutton3");
	v_member = lookup_widget(window1, "checkbutton4");
	v_friend = lookup_widget(window1, "checkbutton5");
	g_public = lookup_widget(window1, "checkbutton6");
	g_member = lookup_widget(window1, "checkbutton7");
	g_friend = lookup_widget(window1, "checkbutton8");
	nick  = lookup_widget(window1, "entry7");
	pass  = lookup_widget(window1, "entry8");
	email = lookup_widget(window1, "entry9");

	vp = (gtk_toggle_button_get_active(v_public)) ? g_strdup("y") : g_strdup("n");
	vm = (gtk_toggle_button_get_active(v_member)) ? g_strdup("y") : g_strdup("n");
	vf = (gtk_toggle_button_get_active(v_friend)) ? g_strdup("y") : g_strdup("n");
	gp = (gtk_toggle_button_get_active(g_public)) ? g_strdup("y") : g_strdup("n");
	gm = (gtk_toggle_button_get_active(g_member)) ? g_strdup("y") : g_strdup("n");
	gf = (gtk_toggle_button_get_active(g_friend)) ? g_strdup("y") : g_strdup("n");

	n = gtk_entry_get_text(nick);
	p = gtk_entry_get_text(pass);
	e = gtk_entry_get_text(email);

	/* if position set manually always use that one */
	if (global_myposition.lat && global_myposition.lon)
	{
		g_sprintf(lat, "%f", global_myposition.lat);
		g_sprintf(lon, "%f", global_myposition.lon);		
	}
	else if (gpsdata)
	{
		g_sprintf(lat, "%f", gpsdata->fix.latitude);
		g_sprintf(lon, "%f", gpsdata->fix.longitude);
	}
	else
	{
		g_sprintf(lat, "0");
		g_sprintf(lon, "0");
	}
	
	curl_global_init(CURL_GLOBAL_ALL);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "lat",
               CURLFORM_COPYCONTENTS, lat,
               CURLFORM_END);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "lon",
               CURLFORM_COPYCONTENTS, lon,
               CURLFORM_END);
	       
	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "nick",
               CURLFORM_COPYCONTENTS, n,
               CURLFORM_END);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "pass",
               CURLFORM_COPYCONTENTS, p,
               CURLFORM_END);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "v_public",
               CURLFORM_COPYCONTENTS, vp,
               CURLFORM_END);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "v_member",
               CURLFORM_COPYCONTENTS, vm,
               CURLFORM_END);
	       	
		
	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "v_friend",
               CURLFORM_COPYCONTENTS, vf,
               CURLFORM_END);
	       
	       
	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "g_public",
               CURLFORM_COPYCONTENTS, gp,
               CURLFORM_END);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "g_member",
               CURLFORM_COPYCONTENTS, gm,
               CURLFORM_END);
	       	
		
	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "g_friend",
               CURLFORM_COPYCONTENTS, gf,
               CURLFORM_END);
	       
	       
	curl_handle = curl_easy_init();
	
	curl_easy_setopt(curl_handle, CURLOPT_URL, "http://www.tangogps.org/friends/update_pos.php");
	curl_easy_setopt(curl_handle, CURLOPT_HTTPPOST, formdata);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, cb_write_to_mem);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEDATA, (void *)&chunk);
	curl_easy_setopt(curl_handle, CURLOPT_USERAGENT, "libcurl-agent/1.0");//TODO - version

//	gtk_label_set_text(label_msg, "Connecting...");

	curl_easy_perform(curl_handle);
	curl_easy_getinfo(curl_handle, CURLINFO_RESPONSE_CODE, &response_code);
	
	
	curl_easy_cleanup(curl_handle);
	
	printf("REPLY: %s - response: %d\n",chunk.memory, response_code);
	
	/* split reply */
	//this is braindead - do taht in one go.
	//printf("reply: %s\n",server_message[1]);
//we crash here if no route / reply empty.!!!

	if (response_code == 200) { //TODO, this needs more extended return code checking

	friends_list = NULL; //TODO this leeeaaaks.
	user_data_sets = g_strsplit_set (chunk.memory, "|", -1);

		
	gdk_threads_enter();
	gtk_label_set_text(label_msg, user_data_sets[0]); //FIXME const
	gdk_threads_leave();
	
	while (!g_str_equal(user_data_sets[i],"EOD") )
	{
		gchar **array;
		
		friend_t *friend = g_new0(friend_t,1);
		
		array = g_strsplit(user_data_sets[i],"#",-1);
		//--creat global type
		//--user data into struct, and append to list
		
		
		//TODO free array gchar **arr1;
		friend->type = atoi(g_strdup(array[0]));
		friend->nick  = g_strdup(array[1]);
		friend->lat = atof(g_strdup(array[2]));printf("##%f\n",friend->lat);
		friend->lon = atof(g_strdup(array[3]));
		friend->head = atoi(g_strdup(array[4]));
		friend->lastseen = g_strdup(array[5]);
		
		friends_list = g_slist_append(friends_list, friend);
		
		
		//printf("userdata(%d): %s %s %s\n",i,user_data[0],user_data[1],user_data[2]);
		i++;
	}
	}
	else
	{
		gdk_threads_enter();
		gtk_label_set_text(label_msg, "No response (200)"); //FIXME const
		gdk_threads_leave();
		
	}
	//TODO this has to go in a function
	//global struct type l.l.n., loop arr->list
	
	//**** paint the dots.
	gdk_threads_enter();
	paint_friends();
	//gdk_flush ();
	gdk_threads_leave();
	//tap mode + popup
	
	//if(chunk.memory)
	//free(chunk.memory);
	
	curl_global_cleanup();
	
	return 0;
}

void
paint_friends()
{	
	GSList *list;
	int pixel_x, pixel_y, x,y;
	float lat, lon;
	GdkColor color;
	GdkGC *gc;
	
	gc = gdk_gc_new(pixmap);
	color.green = 60000;
	color.blue = 0;
	color.red = 10000;
	gdk_gc_set_rgb_fg_color(gc, &color);
	

	
			
		
		
		
	

	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	for(list = friends_list; list != NULL; list = list->next)
	{
		friend_t *f = list->data;
	
		lat = deg2rad(f->lat);
		lon = deg2rad(f->lon);
		
		
		
		// pixel_x,y, offsets
		pixel_x = lon2pixel(global_zoom, lon);
		pixel_y = lat2pixel(global_zoom, lat);
		
		x = pixel_x - global_x;
		y = pixel_y - global_y;
		
		f->screen_x = x;
		f->screen_y = y;
		
		//this should go into another list...
		
		gdk_draw_arc (
			pixmap,
			//map_drawable->style->black_gc,
			gc,
			TRUE,			//filled
			x-4, y-4,		// x,y
			8,8,			// width, height
			0,23040);		// start-end angle 64th, from 3h, anti clockwise
		
		gtk_widget_queue_draw_area (
			map_drawable, 
			x-4, y-4,
			8,8);

		printf("FRIEND: %s lat %f - lon %f\n",f->nick,f->lat, f->lon);
	}
}

void
update_position0()
{
	CURL *curl;
	CURLcode res;

	printf("*** %s(): \n",__PRETTY_FUNCTION__);
	
	curl = curl_easy_init();
	
	if(curl)
	{
		curl_easy_setopt(curl, CURLOPT_URL, 
				"127.0.0.1/friends/update_position.php?lat=1&lon=1");
		res = curl_easy_perform(curl);
		
		curl_easy_cleanup(curl);
	}
	
}


//=============================================================================================
//=============================================================================================
//=============================================================================================
//=============================================================================================
//=============================================================================================

int
register_nick()
{		
	GtkWidget *label_msg;
	label_msg = lookup_widget(window1, "label62");
	gtk_label_set_text(label_msg, "Connecting...");

	printf("*** %s(): \n",__PRETTY_FUNCTION__);

	if (!g_thread_create(&register_nick_thread, NULL, FALSE, NULL) != 0)
		g_warning("### can't create register_nick() thread\n");
}
	
int
register_nick_thread(void *ptr)
{
	int i=1;
	
	GtkWidget *nick, *pass, *email;
	GtkWidget *label_msg;
	const gchar *n, *p, *e;
	gchar *buffer;
	
	gchar **server_message, **user_data_sets, **user_data;
	
	CURL *curl_handle;
	
	struct curl_httppost *formdata=NULL;
	struct curl_httppost *lastptr=NULL;
		
	struct mem_struct chunk;
	
	chunk.memory=NULL;
	chunk.size = 0;
	
	printf("*** %s(): \n",__PRETTY_FUNCTION__);



	/* get the info from the widgets */
	nick  = lookup_widget(window1, "entry7");
	pass  = lookup_widget(window1, "entry8");
	email = lookup_widget(window1, "entry9");

	n = gtk_entry_get_text(nick);
	p = gtk_entry_get_text(pass);
	e = gtk_entry_get_text(email);

	
	curl_global_init(CURL_GLOBAL_ALL);

	       
	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "nick",
               CURLFORM_COPYCONTENTS, n,
               CURLFORM_END);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "pass",
               CURLFORM_COPYCONTENTS, p,
               CURLFORM_END);

	curl_formadd(&formdata,
               &lastptr,
               CURLFORM_COPYNAME, "email",
               CURLFORM_COPYCONTENTS, e,
               CURLFORM_END);

	       
	       
	curl_handle = curl_easy_init();
	
	curl_easy_setopt(curl_handle, CURLOPT_URL, "http://www.tangogps.org/friends/register_nick.php");
	curl_easy_setopt(curl_handle, CURLOPT_HTTPPOST, formdata);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEFUNCTION, cb_write_to_mem);
	curl_easy_setopt(curl_handle, CURLOPT_WRITEDATA, (void *)&chunk);
	curl_easy_setopt(curl_handle, CURLOPT_USERAGENT, "libcurl-agent/1.0");//TODO - version


	curl_easy_perform(curl_handle);
	curl_easy_cleanup(curl_handle);

	printf("REPLY: %s %d \n",chunk.memory, (int)chunk.size);

	if((int)chunk.size > 0){
		buffer = g_strdup(chunk.memory);
	}
	else
		buffer = g_strdup("Oh. Some error occurred...");

	gdk_threads_enter();
	label_msg = lookup_widget(window1, "label62");
	gtk_label_set_text(label_msg, buffer); //FIXME const
	gdk_threads_leave();
	

	//if(chunk.memory)
	//free(chunk.memory);
	
	curl_global_cleanup();
	
	return 0;
}
