/***************************************************************************
 *  Copyright  2008  Marcus Bauer
 *  License    GPLv2
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gps.h> 
#include <stdio.h>
#include <unistd.h>
#include <time.h>
#include "gps_functions.h"
#include "globals.h"

// TODO: know if gpsd is connected -> global

//struct gps_data_t *gpsdata;

void
set_label()
{
	GtkLabel *label,   *label31, *label38, *label39;
	GtkLabel *label40, *label41, *label42, *label43, *label45;
	GtkLabel *label66, *label68, *label70;
	gchar buffer[256];
	int trip_hours, trip_minutes, trip_seconds;
	time_t time_sec;
	struct tm  *ts;
	
	label = lookup_widget(window1, "label4");
	label45 = lookup_widget(window1, "label45");
	label40 = lookup_widget(window1, "label40");
	label41 = lookup_widget(window1, "label41");
	label31 = lookup_widget(window1, "label31");
	label38 = lookup_widget(window1, "label38");
	label39 = lookup_widget(window1, "label39");
	label42 = lookup_widget(window1, "label42");
	label43 = lookup_widget(window1, "label43");
	label66 = lookup_widget(window1, "label66");
	label68 = lookup_widget(window1, "label68");
	label70 = lookup_widget(window1, "label70");
	


	/*g_sprintf(buffer, 
		"<b>%4.1f</b> km/h  a:%.1fm h:%.1f°  t:%.3fkm  d:%.0fm",
		gpsdata->fix.speed * 3.6,
		gpsdata->fix.altitude,
		gpsdata->fix.track,
		trip_distance,
		gpsdata->fix.epv);*/
		
	g_sprintf(buffer, 
		"<b>%4.1f</b> km/h  head:%.0f°  trip:%.3fkm  %d/%d",
		gpsdata->fix.speed * 3.6,
		gpsdata->fix.track,
		trip_distance,
		gpsdata->satellites,gpsdata->satellites_used);
	gtk_label_set_label(label, buffer);
	
	g_sprintf(buffer, "%.3f km", trip_distance);
	gtk_label_set_label(label45,buffer);
	
	g_sprintf(buffer, "%.1f m", gpsdata->fix.eph);
	gtk_label_set_label(label40,buffer);
	
	time_sec = (time_t)gpsdata->fix.time;
	ts = localtime(&time_sec);
	
	strftime(buffer, sizeof(buffer), "%a %Y-%m-%d %H:%M:%S %Z", ts);
	//g_sprintf(buffer, "%f s", gpsdata->fix.time);
	gtk_label_set_label(label41,buffer);

	g_sprintf(buffer, "%f - %f", gpsdata->fix.latitude, gpsdata->fix.longitude);
	gtk_label_set_label(label31,buffer);
if(gpsdata->fix.speed >-1){
	g_sprintf(buffer, "<b><span foreground='#0000ff'><span font_desc='40'>%.1f</span></span></b> km/h", gpsdata->fix.speed*3.6);
	gtk_label_set_label(label38,buffer);
}
else
{
	g_sprintf(buffer, "<b><span foreground='#0000ff'><span font_desc='40'>--</span></span></b> km/h");
	gtk_label_set_label(label38,buffer);

}
	//g_sprintf(buffer, "%.1f m", gpsdata->fix.altitude);
	g_sprintf(buffer, "-");
	gtk_label_set_label(label39,buffer);
	
	g_sprintf(buffer, "%.1f° ", gpsdata->fix.track);
	gtk_label_set_label(label42,buffer);
	
	/*g_sprintf(buffer, "%d / %d - pdop: %.1f fix:%d %d -- %d", 
		gpsdata->satellites,gpsdata->satellites_used,gpsdata->pdop,
		gpsdata->status,gpsdata->fix.mode,gpsdata->used[0]);*/
	g_sprintf(buffer, "%d / %d ", gpsdata->satellites,gpsdata->satellites_used);
	gtk_label_set_label(label43,buffer);

	trip_hours   = trip_time / 3600;
	trip_minutes = ((int)trip_time%3600)/60;
	trip_seconds = (int)trip_time % 60;

		// <10 min,sec;; BEI RESET aUF NULL, global_tripmeter_on =TRUE/FALSE
		printf("TRIPTIME: %.0f - %d:%2d:%2d - %.1f max: %.1f\n", 
			trip_time,trip_hours,trip_minutes,trip_seconds,trip_distance*3600/trip_time,
			trip_maxspeed*3.6);
	
	if (trip_seconds < 10 && trip_minutes < 10)
	{
		g_sprintf(buffer, "  %d:0%d:0%d",trip_hours,trip_minutes,trip_seconds);
	}
	else if (trip_seconds < 10)
		g_sprintf(buffer, "  %d:%d:0%d",trip_hours,trip_minutes,trip_seconds);
	else if (trip_minutes < 10)
		g_sprintf(buffer, "  %d:0%d:%d",trip_hours,trip_minutes,trip_seconds);
	else
		g_sprintf(buffer, "  %d:%d:%d",trip_hours,trip_minutes,trip_seconds);

	gtk_label_set_label(label66,buffer);

	
	g_sprintf(buffer, " %.1f km/h", trip_distance*3600/trip_time);
	gtk_label_set_label(label68,buffer);

	g_sprintf(buffer, " %.1f km/h", trip_maxspeed*3.6);
	gtk_label_set_label(label70,buffer);

}

//TODO: this function is obsolete? remove?
void
process_gps(struct gps_data_t *gpsdata, char *buf, size_t len, int level)
{
	printf("process_gps(): - \n"
		"status: %d setmask: %u	\n"
		"lat: %f lon: %f	\n"
		"mode123: %d		\n"
		"speed: %f \n\n", 
		gpsdata->status,
		gpsdata->set,
		gpsdata->fix.latitude,
		gpsdata->fix.longitude, 
		gpsdata->fix.mode,
		gpsdata->fix.speed//,buf
		);

}

void
get_gps()
{
	int i,res;

	if(!gpsdata)
		gpsdata = gps_open(global_server,global_port);
	if(gpsdata)
	{
		printf("GPSD CONNECT OK\n");
		
		//gps_set_raw_hook(gpsdata, process_gps);
		
		//gps_query(gpsdata,"r+");
		//gps_poll(gpsdata);
		//res = gps_query(gpsdata,"oqy"); //all
		res = gps_query(gpsdata,"w");
		//res = gps_poll(gpsdata);
		//res = gps_poll(gpsdata);
		if (res==-1){printf("POLL ERROR \n");gpsdata=NULL;}
		
		/*for (i=0;i<5;i++){
			res = gps_query(gpsdata,"ogy");
			//res = gps_poll(gpsdata);
			if(res==-1){printf("POLL ERROR \n");}
			//sleep(1);
		}*/
		//gps_close(gpsdata);
		printf("GPSD CONNECT OK DONE\n");
	
	}
	else printf("NOGPS");

	// lat, lon, alt, speed, fix

}



/*
struct gps_data_t *gps_open(char *server, char * port);
void gps_close(struct gps_data_t *gpsdata);

int gps_query(struct gps_data_t *gpsdata, char *requests);
int gps_poll(struct gps_data_t *gpsdata);


void gps_set_raw_hook(	struct gps_data_t *gpsdata,
			void (*hook)(struct gps_data_t *, char *));


void gps_set_callback(	struct gps_data_t *gpsdata,
			void (*callback)(struct gps_data_t *, char *),
			pthread_t *handler);
void gps_del_callback(struct gps_data_t *gpsdata, pthread *handler);

--
gpsdata = gps_open(server, port);

gps_set_raw_hook(gpsdata, myfunc);

(void)gps_query(gpsdata, "w+x0);

gpsdata->gps_fd,
AppMainLoop;

(void)gps_close(gpsdata);
--
set raw_hook
query, poll?

-lgps
*/
