/***************************************************************************
 *  Copyright  2008  Marcus Bauer
 *  License    GPLv2
 ****************************************************************************/

#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gprintf.h>
#include <string.h>
#include <curl/curl.h>
#include <curl/types.h> /* new for v7 */
#include <curl/easy.h> /* new for v7 */
#include "globals.h"
#include "tile_management.h"
#include "map_management.h"

GtkWidget *Bar = NULL; //FIXME curl needed?

	typedef struct  {
		char *tile_url;//[256];//="http://127.0.0.1/el/hq/PICT8433.JPG";
		//char tile_filename[256];//="/tmp/yada";	
	} Repo_data_t;

	

	
int
update_thread_number (int change)
{
	static int current_number = 0;
	int ret_val;
	static GStaticMutex mutex = G_STATIC_MUTEX_INIT;
	
	g_static_mutex_lock (&mutex);
	ret_val = current_number += change; 
	g_static_mutex_unlock (&mutex);


	return ret_val;
}
	
	
gboolean
map_redraw(void *p)
{
	int number_threads;
	number_threads = update_thread_number(0);
	printf("** map_redraw(): %i\n", number_threads);
	// if >1 FALSE
	// if 0 -> fill_tiles_pixel + false
	// else TRUE
	if (number_threads > 1)
	{
		printf("map_redraw: SHOULD NEVER COME HERE - still one thread running\n");
		return TRUE;
	}
	else if (number_threads == 0)
	{
		printf("REPAINTING.............\n");
		fill_tiles_pixel(global_x, global_y, global_zoom);
		return FALSE;
	}
	else
		return TRUE;
}	
	
	
	size_t 
cb_write_func(	void *ptr,
		size_t size,
		size_t nmemb,
		FILE *stream)
{
	printf("%s() %i bytes %i\n", __PRETTY_FUNCTION__,size, nmemb );
	
	return 
	fwrite(ptr, size, nmemb, stream); //hmm man page says this should be size * nmemb;
}


size_t
cb_read_func(void *ptr, size_t size, size_t nmemb, FILE *stream)
{
  return fread(ptr, size, nmemb, stream);
}

int
cb_progress_func(GtkWidget *Bar,
                     double t, /* dltotal */
                     double d, /* dlnow */
                     double ultotal,
                     double ulnow)
{
  printf("progress: %f / %f (%.0f%%)\n", d, t, d*100.0/t);

  return 0;
//FIXME
/*	gdk_threads_enter();
  gtk_progress_set_value(GTK_PROGRESS(Bar), d*100.0/t);
  gdk_threads_leave();
  return 0;
*/
}

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////

void
download_tile(	repo_t *repo,//TODO das sollte eine repo struct sein
		int zoom,
		int x,
		int y)
{
//1. url aus repo
//2. dir aus repo	
	
	gchar *tile_data;
	gchar tile_data_tmp[256];
	gchar tile_url[256];

		
	/* URL constructing */
	if (!repo->inverted_zoom)
		g_sprintf(tile_url, repo->uri, zoom, x, y); //TODO if reversed
	else
		g_sprintf(tile_url, repo->uri, x, y, 17-zoom);
	
	
	/* url | filename | dir */
	g_sprintf(tile_data_tmp, "%s|%s/%d/%d/%d.png|%s/%d/%d/",
			tile_url,
			repo->dir, zoom, x, y,
			repo->dir, zoom, x);
	tile_data = g_strdup(tile_data_tmp);
 	
	printf("%s(): %s######################\n",__PRETTY_FUNCTION__,tile_data);
	
	if (!g_thread_create(&dl_thread, (void *)tile_data, FALSE, NULL) != 0)
		g_warning("can't create DL thread");
	
	
}



////////////////////////////////////////////////////////////////////////
/*-----------------*/
/* download thread */
/*-----------------*/
void *
dl_thread(void *ptr)
{
	CURL *curl;
	CURLcode res;
	FILE *outfile;
	char err_buffer[CURL_ERROR_SIZE];
	int number_threads;

	const gchar *tile_data; //= ptr;
	gchar **arr1;

	int mkres;
	tile_data = ptr;
	
	number_threads = update_thread_number(1);
	printf("\n\n # of threads: %i \n\n", number_threads );
	if (number_threads == 1)
		g_timeout_add(500, map_redraw, NULL); //FIXME that makes no sense here. put down.w/o t/o
	
	arr1 = g_strsplit(tile_data,"|",3);//TODO free array

//outfile = fopen(filename, "w");
	
	// create dir if not exist
	mkres = g_mkdir_with_parents(arr1[2],0700);
	if(mkres==-1) {
		printf("MKDIR ERROR\n\n");
		perror("mkdir........");
	}
	
	printf( "\n\n************************************\n"
		"tile_data: %s \n URL: %s \n FILE: %s \n DIR: %s\n",
		tile_data, arr1[0],arr1[1],arr1[2]);
	
//printf("*************DL_THREAD-#URL# %s ++ %s---\n",tile_url,tile_filename);	
	
	outfile = fopen(arr1[1], "w");
	if (outfile==NULL)
		printf("\n\naieeeeeeeeeeeee: outfile=NULL\n\n\n");

	curl = curl_easy_init();

	if(curl)//FIXMEEEEEEEEEE if ! 
	{
		outfile = fopen(arr1[1], "w");
		
		curl_easy_setopt(curl, CURLOPT_URL, arr1[0]);
		curl_easy_setopt(curl, CURLOPT_USERAGENT, 
		"Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.11) Gecko/20071127 Firefox/2.0.0.11");
		curl_easy_setopt(curl, CURLOPT_WRITEDATA, outfile);
		curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION,	 cb_write_func);
		curl_easy_setopt(curl, CURLOPT_READFUNCTION,	 cb_read_func);
//FIXME
		curl_easy_setopt(curl, CURLOPT_NOPROGRESS, FALSE);
		curl_easy_setopt(curl, CURLOPT_PROGRESSFUNCTION, cb_progress_func);
		curl_easy_setopt(curl, CURLOPT_PROGRESSDATA, Bar);
		curl_easy_setopt(curl, CURLOPT_ERRORBUFFER, err_buffer);
		curl_easy_setopt(curl, CURLOPT_FAILONERROR, 1); //don't write 400 pages
		res = curl_easy_perform(curl);
		if (res==0)
			printf("########## curl res=0, tile download ok\n");
		else
			printf("TILE DL PROBLEM %s\n",err_buffer);
		
		fclose(outfile);
		/* always cleanup */
		curl_easy_cleanup(curl);

		number_threads = update_thread_number(-1);
		printf("curl END: # of running threads: %i \n\n", number_threads );
		
		//if (number_threads == 0)
		//	fill_tiles_pixel(global_x, global_y, global_zoom);	//FIXME zoom

	}

	return NULL;
}
